## ros-rolling-microstrain-inertial-driver 2.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(microstrain_inertial_driver)

# Locate the common code and messages
set(COMMON_NAME "microstrain_inertial_driver_common")
set(COMMON_DIR "${${PROJECT_NAME}_SOURCE_DIR}/${COMMON_NAME}")
set(COMMON_SRC_DIR "${COMMON_DIR}/src")
set(COMMON_INC_DIR "${COMMON_DIR}/include/${COMMON_NAME}")

# Make sure that the submodule has been properly initialized
if(NOT EXISTS "${COMMON_DIR}/src")
  message(STATUS "Initializing ${COMMON_DIR} submodule. This should only happen once.")

  # Make sure we can find the git executable
  find_package(Git)
  if(NOT Git_FOUND)
    message(FATAL_ERROR "Unable to initialize submodule because we could not find the git executable. Please clone this repo using 'git clone --recursive'")
  endif()

  # Initialize and update the submodule
  execute_process(
    WORKING_DIRECTORY "${${PROJECT_NAME}_SOURCE_DIR}"
    COMMAND ${CMAKE_COMMAND} -E env ${GIT_EXECUTABLE} submodule update --init --recursive
  )
endif()

# Download and install MSCL
include(${COMMON_DIR}/cmake/download_mscl.cmake)
download_mscl(VERSION "63.1.0")

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-implicit-function-declaration -Wno-incompatible-pointer-types -fno-builtin-memcpy")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-builtin-memcpy")
endif()

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(ament_cmake REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(rosidl_default_generators REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(nmea_msgs REQUIRED)
find_package(mavros_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(std_srvs REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(microstrain_inertial_msgs REQUIRED)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
ament_export_include_directories()
ament_export_dependencies(
    roscpp
    rosidl_default_runtime
    cmake_modules
    tf2
    tf2_ros
    tf2_geometry_msgs
    std_msgs
    std_srvs
    geometry_msgs
    sensor_msgs
    nav_msgs
    nmea_msgs
    mavros_msgs
    message_runtime
		microstrain_inertial_msgs
)

###########
## Build ##
###########

# Add the catkin includes
include_directories(${catkin_INCLUDE_DIRS} include ${COMMON_DIR}/include)

# Only lint the ROS2 code as the ROS1 code is linted through ROS1 and having two competing standards would make things messy quick
set(NODE_SRC_FILES
  src/microstrain_inertial_driver_node.cpp
)

ament_package()

set(LIB_SRC_FILES
  ${COMMON_SRC_DIR}/microstrain_subscribers.cpp
  ${COMMON_SRC_DIR}/microstrain_publishers.cpp
  ${COMMON_SRC_DIR}/microstrain_node_base.cpp
  ${COMMON_SRC_DIR}/microstrain_services.cpp
  ${COMMON_SRC_DIR}/microstrain_parser.cpp
  ${COMMON_SRC_DIR}/microstrain_config.cpp
  src/microstrain_inertial_driver.cpp
)
set(LIB_INC_FILES
  ${COMMON_INC_DIR}/microstrain_subscribers.h
  ${COMMON_INC_DIR}/microstrain_publishers.h
  ${COMMON_INC_DIR}/microstrain_node_base.h
  ${COMMON_INC_DIR}/microstrain_services.h
  ${COMMON_INC_DIR}/microstrain_parser.h
  ${COMMON_INC_DIR}/microstrain_config.h
  ${COMMON_INC_DIR}/microstrain_defs.h
  ${COMMON_INC_DIR}/microstrain_ros_funcs.h
  include/${PROJECT_NAME}/microstrain_inertial_driver.h
)
add_library(${PROJECT_NAME} ${LIB_SRC_FILES} ${LIB_INC_FILES})
ament_target_dependencies(${PROJECT_NAME}
  rclcpp
  rclcpp_lifecycle
  std_msgs
  std_srvs
  lifecycle_msgs
  sensor_msgs
  geometry_msgs
  nav_msgs
  nmea_msgs
  mavros_msgs
  tf2
  tf2_ros
  tf2_geometry_msgs
  microstrain_inertial_msgs
)

# Executables
add_executable(${PROJECT_NAME}_node ${NODE_SRC_FILES} ${NODE_INC_FILES})

# Let the code know if it is being compiled with ROS1 or ROS2
if(DEFINED ENV{ROS_VERSION})
  add_definitions(-DMICROSTRAIN_ROS_VERSION=$ENV{ROS_VERSION})
else()
  message(FATAL_ERROR "ROS_VERSION environment variable is not set.")
endif()

# Some ROS version specific defines
if(DEFINED ENV{ROS_DISTRO})
  if ("$ENV{ROS_DISTRO}" STREQUAL "rolling")
    add_definitions(-DMICROSTRAIN_ROLLING=1)
  elseif ("$ENV{ROS_DISTRO}" STREQUAL "galactic")
    add_definitions(-DMICROSTRAIN_GALACTIC=1)
  elseif ("$ENV{ROS_DISTRO}" STREQUAL "foxy")
    add_definitions(-DMICROSTRAIN_FOXY=1)
  else()
    add_definitions(-DMICROSTRAIN_ROLLING=1)  # By default assume this is a newer ROS version than we support, so rolling define is the safest
  endif()
endif()

# Allow the MSCL include directory to be accessed
include_directories(${MSCL_INC_PATH} ${BOOST_INC_PATH})

# Linking
target_link_libraries(${PROJECT_NAME}
  ${MSCL_LIB_PATH}
  ${catkin_LIBRARIES}
)
target_link_libraries(${PROJECT_NAME}_node
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
)

#############
## Install ##
#############

install(TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_node
  DESTINATION share/${PROJECT_NAME}
  LIBRARY DESTINATION lib/${PROJECT_NAME}
  RUNTIME DESTINATION lib/${PROJECT_NAME}
  PUBLIC_HEADER DESTINATION include/${PROJECT_NAME}
)

install(DIRECTORY launch config
  DESTINATION share/${PROJECT_NAME}
)

install(DIRECTORY ${COMMON_DIR}/config
  DESTINATION share/${PROJECT_NAME}/${COMMON_NAME}
)

# We also have to install MSCL and it's dependencies so it can be found at runtime
file(GLOB BOOST_LIBS "${MSCL_DIR}/Boost/lib/*")
install(FILES ${BOOST_LIBS} ${MSCL_DIR}/libmscl.so
  DESTINATION lib
)

=== debian/changelog ===
ros-rolling-microstrain-inertial-driver (2.5.0-1focal) focal; urgency=high

  * Only attempts to publish GNSS aiding status if the pointer has been initialized
  * Added RTK v2 support
    * Upgraded to MSCL 63.1.0
  * Adds ability to use ROS time when populating messages
  * Fixes "does not support" logs
  * Fixed submodule initialization
  * Contributors: dacuster, robbiefish

 -- Rob Fisher <rob.fisher@parker.com>  Thu, 27 Jan 2022 05:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.4.0-1focal) focal; urgency=high

  * BREAKING: Changes default namespace from /gx5 to / which is more generic to all usecases as customers are often not using a gx5 device
  * BREAKING: Changes the name argument to namespace which is more descriptive of what it was doing
  * Moves most launch file parameters to yml file and allows user to override all default parameters by specifying a different yml file via the params_file argument
  * Adds new argument node_name to launch file that allows users to change the name of the node
  * Adds documentation for each launch file argument
  * Contributors: robbiefish

 -- Rob Fisher <rob.fisher@parker.com>  Wed, 05 Jan 2022 05:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.3.0-1focal) focal; urgency=high

  * BREAKING: Updates device_report_service to return the device information instead of just printing it
  * Publishes Aiding Measurement Summary messages to topic nav/aiding_summary
  * Publishes Fix Info messages to topic gnss1/fix_info and gnss2/fix_info
  * Contributors: robbiefish

 -- Rob Fisher <rob.fisher@parker.com>  Wed, 22 Dec 2021 05:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.2.0-1focal) focal; urgency=high

  * Adds set filter speed lever arm service to allow users to configure Measurement Speed Lever Arm at runtime with a service call
  * Subscribes to external speed measurements
  * Adds ability to configure hardware odometer at config time by sending the Odometer Settings command based on launch config
  * Adds RTCM subscriber that will subscribe to RTCM corrections as mavros_msgs/RTCM messages and send them to the GQ7 through the aux port
  * Adds NMEA publisher that will read NMEA sentences from the GQ7 aux port and publish them as nmea_msgs/Sentence messages to a topic
  * Updates to use FACTORY_STREAMING_MERGE instead of manually casting the hex value when factory streaming is enabled
  * Updates udev rules to differentiate between main and aux ports
  * Contributors: ianmooreparker, robbiefish

 -- Rob Fisher <rob.fisher@parker.com>  Fri, 03 Dec 2021 05:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.1.0-1focal) focal; urgency=high

  * Adds transform broadcaster that will publish transform between filter_frame_id and filter_child_frame_id
  * Corrects some ENU conversions that were not being properly made
  * Properly disables/enables RTK dongle based on launch config
  * Publishes RTK data even when device_setup is set to false if the device was configured to send RTK data
  * Contributors: ianmooreparker, robbiefish

 -- Rob Fisher <rob.fisher@parker.com>  Fri, 12 Nov 2021 05:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.0.6-1focal) focal; urgency=high

  * Fixes CMake build errors experienced on the build farm
  * Contributors: Rob Fisher, robbiefish

 -- Rob Fisher <rob.fisher@parker.com>  Fri, 22 Oct 2021 04:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.0.5-1focal) focal; urgency=high

  * Updates maintainers and dependencies in preparation for ROS build farm
  * Updates submodule to check for correct architecture
  * Moves submodules to subdirectory to get bloom working
  * Renames packages to be more consistent with ROS naming conventions
  * Contributors: Rob Fisher, robbiefish

 -- Rob Fisher <rob.fisher@parker.com>  Thu, 21 Oct 2021 04:00:00 -0000

ros-rolling-microstrain-inertial-driver (1.1.4-1focal) focal; urgency=high

  * Installs MSCL from CMake to hopefully allow this package to be built in the buildfarm
  * Merge pull request #70 <https://github.com/LORD-MicroStrain/ROS-MSCL/issues/70> from ori-drs/master
    [ros_mscl] Turn filter_data_rate and imu_data_rate into an argument
  * [ros_mscl] Turn filter_data_rate and imu_data_rate into an argument
  * Eliminated build warnings
  * Fixed a bug that wouldn't allow the rtk dongle to be enabled as it was using the wrong variable to enable it.
  * See changelog
  * Added aiding measurement summary for each GNSS (GQ7 only)
    Added MSCL version output when node starts
  * Merge pull request #50 <https://github.com/LORD-MicroStrain/ROS-MSCL/issues/50> from civerachb-cpr/master
    Add an arg to enable setting NED/ENU frame parameter
  * Add an arg to enable setting NED/ENU frame parameter
  * Contributors: Chris Iverach-Brereton, Nathan Miller, Wolfgang Merkt, nathanmillerparker, robbiefish

 -- Rob Fisher <rob.fisher@parker.com>  Fri, 30 Jul 2021 04:00:00 -0000

ros-rolling-microstrain-inertial-driver (1.1.3-1focal) focal; urgency=high

  * Removed duplicate Filter LLH Pos entry in message format
    Preparing for release on Bloom
  * Merge pull request #49 <https://github.com/LORD-MicroStrain/ROS-MSCL/issues/49> from civerachb-cpr/rosdep-fix
    Add tf2_geometry_msgs as a dependency
  * Add tf2_geometry_msgs as a dependency
  * Merge pull request #48 <https://github.com/LORD-MicroStrain/ROS-MSCL/issues/48> from civerachb-cpr/master
    Make frame IDs configurable
  * Add args for all of the frame ids to allow them to be modified when launching.  Keep the old static values as the defaults.
  * Added frame ids back in to not break existing configurations
  * Added a flag to set ENU as the local reference frame
    Moved sensor2vehicle frame transformation setting code to occur if filter data is not enabled
    See changelog for more info
  * Added user notifications in the case a command isn't supported by a device.
    Added support for the speedometer lever arm offset command


=== debian/control ===
Source: ros-rolling-microstrain-inertial-driver
Section: misc
Priority: optional
Maintainer: Rob Fisher <rob.fisher@parker.com>
Build-Depends: debhelper (>= 9.0.0), curl, jq, libcurl4-openssl-dev, ros-rolling-ament-cmake-gtest, ros-rolling-ament-cpplint, ros-rolling-diagnostic-updater, ros-rolling-geometry-msgs, ros-rolling-lifecycle-msgs, ros-rolling-mavros-msgs, ros-rolling-microstrain-inertial-msgs, ros-rolling-nav-msgs, ros-rolling-nmea-msgs, ros-rolling-rclcpp-lifecycle, ros-rolling-ros-environment, ros-rolling-rosidl-default-generators, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-ros-workspace, ros-rolling-rosidl-typesupport-fastrtps-c, ros-rolling-rosidl-typesupport-fastrtps-cpp
Homepage: https://github.com/LORD-MicroStrain/microstrain_inertial
Standards-Version: 3.9.2

Package: ros-rolling-microstrain-inertial-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-diagnostic-aggregator, ros-rolling-diagnostic-updater, ros-rolling-geometry-msgs, ros-rolling-lifecycle-msgs, ros-rolling-mavros-msgs, ros-rolling-microstrain-inertial-msgs, ros-rolling-nav-msgs, ros-rolling-nmea-msgs, ros-rolling-rclcpp-lifecycle, ros-rolling-rosidl-default-runtime, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-ros-workspace
Description: The ros_mscl package provides a driver for the LORD/Microstrain inertial products.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-microstrain-inertial-driver//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-microstrain-inertial-driver 3.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,39 @@
 cmake_minimum_required(VERSION 3.5)
 project(microstrain_inertial_driver)
+
+# C++ 14 required
+set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_STANDARD_REQUIRED ON)
+
+# Force some options for this module and the MIP SDK
+set(BUILD_SHARED_LIBS_TEMP "${BUILD_SHARED_LIBS}")
+set(BUILD_EXAMPLES_TEMP "${BUILD_EXAMPLES}")
+set(BUILD_TESTING_TEMP "${BUILD_TESTING}")
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "" FORCE)
+set(BUILD_EXAMPLES OFF CACHE BOOL "" FORCE)
+set(BUILD_TESTING OFF CACHE BOOL "" FORCE)
 
 # Locate the common code and messages
 set(COMMON_NAME "microstrain_inertial_driver_common")
 set(COMMON_DIR "${${PROJECT_NAME}_SOURCE_DIR}/${COMMON_NAME}")
 set(COMMON_SRC_DIR "${COMMON_DIR}/src")
 set(COMMON_INC_DIR "${COMMON_DIR}/include/${COMMON_NAME}")
+set(MIP_SDK_DIR "${COMMON_DIR}/mip_sdk")
+set(MIP_SDK_SRC_DIR "${MIP_SDK_DIR}/src")
+
+# Some helpful options for debugging
+add_compile_options($<$<CONFIG:DEBUG>:-ggdb>)
+
+# Try to find Git
+find_package(Git)
 
 # Make sure that the submodule has been properly initialized
-if(NOT EXISTS "${COMMON_DIR}/src")
+if(NOT EXISTS "${COMMON_SRC_DIR}")
   message(STATUS "Initializing ${COMMON_DIR} submodule. This should only happen once.")
 
   # Make sure we can find the git executable
-  find_package(Git)
   if(NOT Git_FOUND)
     message(FATAL_ERROR "Unable to initialize submodule because we could not find the git executable. Please clone this repo using 'git clone --recursive'")
   endif()
@@ -20,18 +41,36 @@
   # Initialize and update the submodule
   execute_process(
     WORKING_DIRECTORY "${${PROJECT_NAME}_SOURCE_DIR}"
-    COMMAND ${CMAKE_COMMAND} -E env ${GIT_EXECUTABLE} submodule update --init --recursive
+    COMMAND ${CMAKE_COMMAND} -E env ${GIT_EXECUTABLE} submodule update --recursive --init
   )
 endif()
 
-# Download and install MSCL
-include(${COMMON_DIR}/cmake/download_mscl.cmake)
-download_mscl(VERSION "63.1.0")
-
-# Default to C++14
-if(NOT CMAKE_CXX_STANDARD)
-  set(CMAKE_CXX_STANDARD 14)
-endif()
+# Use Git to find the version
+set(DEFAULT_DRIVER_GIT_VERSION "unknown")
+if(NOT GIT_FOUND)
+  message(STATUS "Unable to find git, will build with unknown version")
+  set(DRIVER_GIT_VERSION ${DEFAULT_DRIVER_GIT_VERSION})
+else()
+  execute_process(
+    COMMAND ${CMAKE_COMMAND} -E env ${GIT_EXECUTABLE} describe --tags
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+    OUTPUT_VARIABLE DRIVER_GIT_VERSION_OUT
+    ERROR_VARIABLE DRIVER_GIT_VERSION_ERR
+    RESULT_VARIABLE DRIVER_GIT_VERSION_RET
+  )
+  if(NOT ${DRIVER_GIT_VERSION_RET} EQUAL 0)
+    message(STATUS "Unable to determine version from Git, defaulting to version ${DEFAULT_DRIVER_GIT_VERSION}")
+    set(DRIVER_GIT_VERSION ${DEFAULT_DRIVER_GIT_VERSION})
+  else()
+    set(DRIVER_GIT_VERSION ${DRIVER_GIT_VERSION_OUT})
+    string(REGEX REPLACE "\n" "" DRIVER_GIT_VERSION "${DRIVER_GIT_VERSION}")
+    message(STATUS "Microstrain Driver Version: ${DRIVER_GIT_VERSION}")
+  endif()
+endif()
+
+# Include the MIP SDK source
+add_subdirectory("${MIP_SDK_DIR}" EXCLUDE_FROM_ALL)
+include_directories("${MIP_SDK_SRC_DIR}")
 
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-implicit-function-declaration -Wno-incompatible-pointer-types -fno-builtin-memcpy")
@@ -102,23 +141,38 @@
 ament_package()
 
 set(LIB_SRC_FILES
-  ${COMMON_SRC_DIR}/microstrain_subscribers.cpp
-  ${COMMON_SRC_DIR}/microstrain_publishers.cpp
-  ${COMMON_SRC_DIR}/microstrain_node_base.cpp
-  ${COMMON_SRC_DIR}/microstrain_services.cpp
-  ${COMMON_SRC_DIR}/microstrain_parser.cpp
-  ${COMMON_SRC_DIR}/microstrain_config.cpp
+  ${COMMON_SRC_DIR}/subscribers.cpp
+  ${COMMON_SRC_DIR}/publishers.cpp
+  ${COMMON_SRC_DIR}/node_common.cpp
+  ${COMMON_SRC_DIR}/services.cpp
+  ${COMMON_SRC_DIR}/config.cpp
+
+  ${COMMON_SRC_DIR}/utils/mappings/mip_mapping.cpp
+  ${COMMON_SRC_DIR}/utils/mappings/mip_publisher_mapping.cpp
+
+  ${COMMON_SRC_DIR}/utils/mip/ros_mip_device.cpp
+  ${COMMON_SRC_DIR}/utils/mip/ros_mip_device_main.cpp
+  ${COMMON_SRC_DIR}/utils/mip/ros_mip_device_aux.cpp
+  ${COMMON_SRC_DIR}/utils/mip/ros_connection.cpp
+
   src/microstrain_inertial_driver.cpp
 )
 set(LIB_INC_FILES
-  ${COMMON_INC_DIR}/microstrain_subscribers.h
-  ${COMMON_INC_DIR}/microstrain_publishers.h
-  ${COMMON_INC_DIR}/microstrain_node_base.h
-  ${COMMON_INC_DIR}/microstrain_services.h
-  ${COMMON_INC_DIR}/microstrain_parser.h
-  ${COMMON_INC_DIR}/microstrain_config.h
-  ${COMMON_INC_DIR}/microstrain_defs.h
-  ${COMMON_INC_DIR}/microstrain_ros_funcs.h
+  ${COMMON_INC_DIR}/subscribers.h
+  ${COMMON_INC_DIR}/publishers.h
+  ${COMMON_INC_DIR}/node_common.h
+  ${COMMON_INC_DIR}/services.h
+  ${COMMON_INC_DIR}/config.h
+  ${COMMON_INC_DIR}/utils/ros_compat.h
+
+  ${COMMON_INC_DIR}/utils/mappings/mip_mapping.h
+  ${COMMON_INC_DIR}/utils/mappings/mip_publisher_mapping.h
+
+  ${COMMON_INC_DIR}/utils/mip/ros_mip_device.h
+  ${COMMON_INC_DIR}/utils/mip/ros_mip_device_main.h
+  ${COMMON_INC_DIR}/utils/mip/ros_mip_device_aux.h
+  ${COMMON_INC_DIR}/utils/mip/ros_connection.h
+
   include/${PROJECT_NAME}/microstrain_inertial_driver.h
 )
 add_library(${PROJECT_NAME} ${LIB_SRC_FILES} ${LIB_INC_FILES})
@@ -142,6 +196,12 @@
 # Executables
 add_executable(${PROJECT_NAME}_node ${NODE_SRC_FILES} ${NODE_INC_FILES})
 
+# Annoying, but the ROS types don't match up with the MIP types for floats and doubles, so ignore those warnings for now
+set_source_files_properties(${COMMON_SRC_DIR}/services.cpp PROPERTIES COMPILE_OPTIONS "-Wno-narrowing")
+
+# Tell the code the version of the driver that is being build
+add_definitions(-DMICROSTRAIN_DRIVER_VERSION="${DRIVER_GIT_VERSION}")
+
 # Let the code know if it is being compiled with ROS1 or ROS2
 if(DEFINED ENV{ROS_VERSION})
   add_definitions(-DMICROSTRAIN_ROS_VERSION=$ENV{ROS_VERSION})
@@ -153,6 +213,8 @@
 if(DEFINED ENV{ROS_DISTRO})
   if ("$ENV{ROS_DISTRO}" STREQUAL "rolling")
     add_definitions(-DMICROSTRAIN_ROLLING=1)
+  elseif ("$ENV{ROS_DISTRO}" STREQUAL "humble")
+    add_definitions(-DMICROSTRAIN_HUMBLE=1)
   elseif ("$ENV{ROS_DISTRO}" STREQUAL "galactic")
     add_definitions(-DMICROSTRAIN_GALACTIC=1)
   elseif ("$ENV{ROS_DISTRO}" STREQUAL "foxy")
@@ -162,12 +224,9 @@
   endif()
 endif()
 
-# Allow the MSCL include directory to be accessed
-include_directories(${MSCL_INC_PATH} ${BOOST_INC_PATH})
-
 # Linking
 target_link_libraries(${PROJECT_NAME}
-  ${MSCL_LIB_PATH}
+  mip
   ${catkin_LIBRARIES}
 )
 target_link_libraries(${PROJECT_NAME}_node
@@ -179,7 +238,7 @@
 ## Install ##
 #############
 
-install(TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_node
+install(TARGETS ${PROJECT_NAME}_node
   DESTINATION share/${PROJECT_NAME}
   LIBRARY DESTINATION lib/${PROJECT_NAME}
   RUNTIME DESTINATION lib/${PROJECT_NAME}
@@ -194,8 +253,7 @@
   DESTINATION share/${PROJECT_NAME}/${COMMON_NAME}
 )
 
-# We also have to install MSCL and it's dependencies so it can be found at runtime
-file(GLOB BOOST_LIBS "${MSCL_DIR}/Boost/lib/*")
-install(FILES ${BOOST_LIBS} ${MSCL_DIR}/libmscl.so
-  DESTINATION lib
-)
+# Reset the forced options
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "${BUILD_SHARED_LIBS_TEMP}" FORCE)
+set(BUILD_EXAMPLES OFF CACHE BOOL "${BUILD_EXAMPLES_TEMP}" FORCE)
+set(BUILD_TESTING OFF CACHE BOOL "${BUILD_TESTING_TEMP}" FORCE)

=== microstrain_inertial_driver_common/mip_sdk/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

project(
    "MIP SDK"
    VERSION "0.0.01"
    DESCRIPTION "MicroStrain Communications Library for embedded systems"
    LANGUAGES C CXX
)

set(SRC_DIR "${CMAKE_CURRENT_LIST_DIR}/src")
set(EXT_DIR "${CMAKE_CURRENT_LIST_DIR}/ext")
set(MIP_CMAKE_DIR "${CMAKE_CURRENT_LIST_DIR}/cmake")

include_directories(
    "${SRC_DIR}"
)

if(WITH_INTERNAL)
    set(MIP_INTERNAL_DIR "int" CACHE PATH "")
    if(MIP_INTERNAL_DIR)
        add_subdirectory("${MIP_INTERNAL_DIR}" "${CMAKE_CURRENT_BINARY_DIR}/mip-internal")
    endif()
endif()

set(MIP_DIR "${SRC_DIR}/mip")

# Use Git to find the version
find_package(Git)
set(DEFAULT_MIP_GIT_VERSION "v0.0.0")
if(NOT GIT_FOUND)
  message(STATUS "Unable to find git, will build with unknown version")
  set(MIP_GIT_VERSION ${DEFAULT_MSCL_GIT_VERSION})
else()
  execute_process(
    COMMAND ${CMAKE_COMMAND} -E env ${GIT_EXECUTABLE} describe --tags
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE MIP_GIT_VERSION_OUT
    ERROR_VARIABLE MIP_GIT_VERSION_ERR
    RESULT_VARIABLE MIP_GIT_VERSION_RET
  )
  if(NOT ${MIP_GIT_VERSION_RET} EQUAL 0)
    message(STATUS "Unable to determine version from Git, defaulting to version ${DEFAULT_MIP_GIT_VERSION}")
    set(MIP_GIT_VERSION ${DEFAULT_MIP_GIT_VERSION})
  else()
    set(MIP_GIT_VERSION ${MIP_GIT_VERSION_OUT})
    string(REGEX REPLACE "\n" "" MIP_GIT_VERSION "${MIP_GIT_VERSION}")
    message(STATUS "MIP SDK Version: ${MIP_GIT_VERSION}")
  endif()
endif()

# Massage the version number a little so we can use it in a couple places
string(REGEX REPLACE "^v?([0-9]+)\\.([0-9]+)\\.([0-9]+).*" "\\1.\\2.\\3" MIP_GIT_VERSION_CLEAN ${MIP_GIT_VERSION})
string(REPLACE "." ";" MIP_GIT_VERSION_LIST ${MIP_GIT_VERSION_CLEAN})
list(LENGTH MIP_GIT_VERSION_LIST MIP_GIT_VERSION_LIST_LENGTH)
if (MIP_GIT_VERSION_LIST_LENGTH GREATER_EQUAL 3)
    list(GET MIP_GIT_VERSION_LIST 0 MIP_GIT_VERSION_MAJOR)
    list(GET MIP_GIT_VERSION_LIST 1 MIP_GIT_VERSION_MINOR)
    list(GET MIP_GIT_VERSION_LIST 2 MIP_GIT_VERSION_PATCH)
else()
    message(WARNING "MIP version cannot be parsed into a semantic version string.\nPlease run 'git fetch --tags' to get a properly tagged build")
    set(MIP_GIT_VERSION_CLEAN "0.0.0")
    set(MIP_GIT_VERSION_MAJOR 0)
    set(MIP_GIT_VERSION_MINOR 0)
    set(MIP_GIT_VERSION_PATCH 0)
endif()

# Generate the version header file
set(VERSION_IN_FILE "${MIP_CMAKE_DIR}/mip_version.h.in")
set(VERSION_OUT_FILE "${MIP_DIR}/mip_version.h")
configure_file(${VERSION_IN_FILE} ${VERSION_OUT_FILE})

#
# Build options
#

option(MIP_USE_SERIAL "Build serial connection support into the library and examples" ON)
option(MIP_USE_TCP    "Build TCP connection support into the library and exampels" ON)
option(MIP_USE_EXTRAS "Build extra support into the library including some things that might work at a higher level and use dynamically allocated memory" ON)
option(MIP_ENABLE_DIAGNOSTICS "Enable various diagnostic counters in the mip library for debugging." OFF)

option(MIP_ENABLE_LOGGING "Build with logging functions enabled" ON)
set(MIP_LOGGING_MAX_LEVEL "" CACHE STRING "Max log level the SDK is allowed to log. If this is defined, any log level logged at a higher level than this will result in a noop regardless of runtime configuration.")

set(MIP_TIMESTAMP_TYPE "uint64_t" CACHE STRING "Override the type used for received data timestamps and timeouts (must be unsigned or at least 64 bits).")

option(BUILD_PACKAGE "Whether to build a package from the resulting binaries" OFF)

#
# Utils
#

set(UTILS_DIR "${MIP_DIR}/utils")

set(UTILS_SOURCES
    "${UTILS_DIR}/byte_ring.c"
    "${UTILS_DIR}/byte_ring.h"
    "${UTILS_DIR}/serialization.c"
    "${UTILS_DIR}/serialization.h"
)

#
# MIP Control
#

set(MIP_SOURCES
    "${VERSION_OUT_FILE}"
    "${MIP_DIR}/mip_cmdqueue.c"
    "${MIP_DIR}/mip_cmdqueue.h"
    "${MIP_DIR}/mip_dispatch.c"
    "${MIP_DIR}/mip_dispatch.h"
    "${MIP_DIR}/mip_field.c"
    "${MIP_DIR}/mip_field.h"
    "${MIP_DIR}/mip_offsets.h"
    "${MIP_DIR}/mip_packet.c"
    "${MIP_DIR}/mip_packet.h"
    "${MIP_DIR}/mip_parser.c"
    "${MIP_DIR}/mip_parser.h"
    "${MIP_DIR}/mip_result.c"
    "${MIP_DIR}/mip_result.h"
    "${MIP_DIR}/mip_types.h"
    "${MIP_DIR}/definitions/descriptors.c"
    "${MIP_DIR}/definitions/descriptors.h"
    "${MIP_DIR}/mip.hpp"
    "${MIP_DIR}/mip_all.h"
)

set(MIPDEV_SOURCES
    "${MIP_DIR}/mip_interface.c"
    "${MIP_DIR}/mip_interface.h"
    "${MIP_DIR}/mip_device.cpp"
    "${MIP_DIR}/mip_device.hpp"
)

set(MIPDEF_SOURCES
    "${MIP_DIR}/definitions/commands_3dm.c"
    "${MIP_DIR}/definitions/commands_3dm.h"
    "${MIP_DIR}/definitions/commands_base.c"
    "${MIP_DIR}/definitions/commands_base.h"
    "${MIP_DIR}/definitions/commands_filter.c"
    "${MIP_DIR}/definitions/commands_filter.h"
    "${MIP_DIR}/definitions/commands_gnss.c"
    "${MIP_DIR}/definitions/commands_gnss.h"
    "${MIP_DIR}/definitions/commands_rtk.c"
    "${MIP_DIR}/definitions/commands_rtk.h"
    "${MIP_DIR}/definitions/commands_system.c"
    "${MIP_DIR}/definitions/commands_system.h"
    "${MIP_DIR}/definitions/data_filter.c"
    "${MIP_DIR}/definitions/data_filter.h"
    "${MIP_DIR}/definitions/data_gnss.c"
    "${MIP_DIR}/definitions/data_gnss.h"
    "${MIP_DIR}/definitions/data_sensor.c"
    "${MIP_DIR}/definitions/data_sensor.h"
    "${MIP_DIR}/definitions/data_shared.c"
    "${MIP_DIR}/definitions/data_shared.h"
    "${MIP_DIR}/definitions/data_system.c"
    "${MIP_DIR}/definitions/data_system.h"
    ${INTDEF_SOURCES}
)

string(REGEX REPLACE "\.h(;|$)" ".hpp\\1" MIPDEF_HPP_SOURCES "${MIPDEF_SOURCES}")
string(REGEX REPLACE "\.c(;|$)" ".cpp\\1" MIPDEF_CPP_SOURCES "${MIPDEF_HPP_SOURCES}")

if(MIP_USE_SERIAL)
    list(APPEND UTILS_SOURCES
        "${UTILS_DIR}/serial_port.c"
        "${UTILS_DIR}/serial_port.h"
    )
    list(APPEND MIP_INTERFACE_SOURCES
        "${MIP_DIR}/platform/serial_connection.hpp"
        "${MIP_DIR}/platform/serial_connection.cpp"
    )
endif()
if(MIP_USE_TCP)
    list(APPEND UTILS_SOURCES
        "${UTILS_DIR}/tcp_socket.c"
        "${UTILS_DIR}/tcp_socket.h"
    )
    list(APPEND MIP_INTERFACE_SOURCES
        "${MIP_DIR}/platform/tcp_connection.hpp"
        "${MIP_DIR}/platform/tcp_connection.cpp"
    )
endif()
if(MIP_USE_EXTRAS)
    set(MIP_EXTRAS_DIR "${MIP_DIR}/extras")
    set(MIP_EXTRA_SOURCES
        "${MIP_EXTRAS_DIR}/recording_connection.hpp"
        "${MIP_EXTRAS_DIR}/recording_connection.cpp"
    )
endif()

# Logging is a little weird since we need to install the header no matter what
list(APPEND MIP_SOURCES "${MIP_DIR}/mip_logging.h")
if(MIP_ENABLE_LOGGING)
    list(APPEND MIP_SOURCES "${MIP_DIR}/mip_logging.c")
    list(APPEND MIP_DEFINES "MIP_ENABLE_LOGGING")
endif()

set(ALL_MIP_SOURCES
    ${MIPDEF_SOURCES}
    ${MIPDEF_CPP_SOURCES}
    ${MIPDEV_SOURCES}
    ${MIP_SOURCES}
    ${UTILS_SOURCES}
    ${MIP_CPP_HEADERS}
    ${MIP_INTERFACE_SOURCES}
    ${MIP_EXTRA_SOURCES}
)

option(MIP_DISABLE_CPP "Excludes all C++ files from the project." OFF)
if(MIP_DISABLE_CPP)
    list(FILTER ALL_MIP_SOURCES EXCLUDE REGEX "[c|h]pp$")
endif()

add_library(mip ${ALL_MIP_SOURCES})

#
# Preprocessor definitions
#

if(${MIP_LOGGING_MAX_LEVEL})
    list(APPEND MIP_DEFINES "MIP_LOGGING_MAX_LEVEL=${MIP_LOGGING_MAX_LEVEL}")
endif()

if(${MIP_TIMESTAMP_TYPE})
    list(APPEND MIP_DEFINES "MIP_TIMESTAMP_TYPE=${MIP_TIMESTAMP_TYPE}")
endif()

if(${MIP_ENABLE_DIAGNOSTICS})
    list(APPEND MIP_DEFINES "MIP_ENABLE_DIAGNOSTICS")
endif()

# Disable windows defined min/max
if(WIN32)
  list(APPEND MIP_DEFINES "NOMINMAX=1")
endif()

if(MSVC)
  target_compile_options(mip PRIVATE /W4)
else()
  target_compile_options(mip PRIVATE -Wall -Wextra)
endif()

target_compile_definitions(mip PUBLIC "${MIP_DEFINES}")

#
# TESTING
#

# CTest defines this option to ON by default, so override it to OFF here.
option(BUILD_TESTING "Build the testing tree." OFF)

include(CTest)

if(BUILD_TESTING)
    add_subdirectory("test")
endif()

#
# EXAMPLES
#

option(BUILD_EXAMPLES "Builds the example programs." ON)

if(BUILD_EXAMPLES)
    add_subdirectory("examples")
endif()

#
# DOCUMENTATION
#

find_package(Doxygen)
option(BUILD_DOCUMENTATION       "Build the documentation." OFF)
option(BUILD_DOCUMENTATION_FULL  "Build the full (internal) documentation." OFF)
option(BUILD_DOCUMENTATION_QUIET "Suppress doxygen standard output." ON)

if(BUILD_DOCUMENTATION)
    if(NOT DOXYGEN_FOUND)
        message(FATAL_ERROR "Doxygen is required to build documentation.")
    endif()

    set(DOXYGEN_PROJECT_NUMBER "${MIP_GIT_VERSION}")

    set(DOXYGEN_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/documentation")
    set(DOXYGEN_IMAGE_PATH "${CMAKE_CURRENT_LIST_DIR}/docs")

    set(DOXYGEN_WARN_IF_UNDOCUMENTED NO)

    if(NOT MIP_DISABLE_CPP)
        set(DOXYGEN_PREDEFINED "__cplusplus")
    endif()

    set(DOXYGEN_EXTRACT_ALL YES)

    if(BUILD_DOCUMENTATION_FULL)
        set(DOXYGEN_INTERNAL_DOCS YES)
        # set(DOXYGEN_WARN_AS_ERROR YES)
    else()
        set(DOXYGEN_HIDE_UNDOC_MEMBERS YES)
        set(DOXYGEN_HIDE_UNDOC_CLASSES YES)
    endif()

    if(BUILD_DOCUMENTATION_QUIET)
        set(DOXYGEN_QUIET YES)
    endif()

    doxygen_add_docs(docs
        "${SRC_DIR}" "${CMAKE_CURRENT_LIST_DIR}/docs"
        COMMENT "Generating documentation."
    )

    # Add a target to enable users to zip up the docs
    add_custom_target(package_docs
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/documentation/html
        DEPENDS docs
        COMMAND ${CMAKE_COMMAND} -E tar "cf" "${CMAKE_CURRENT_BINARY_DIR}/mipsdk_${MIP_GIT_VERSION}_Documentation.zip" --format=zip "."
    )
endif(BUILD_DOCUMENTATION)

#
# Packaging
#

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(CONFIG_EXPORT_DIR "${CMAKE_INSTALL_DATADIR}/cmake/mip")

set(EXPORT_TARGETS mip)
configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/cmake/mip-config.cmake.in"
    "${CMAKE_BINARY_DIR}/mip-config.cmake"
    INSTALL_DESTINATION "${CONFIG_EXPORT_DIR}"
    PATH_VARS CMAKE_INSTALL_INCLUDEDIR CONFIG_EXPORT_DIR
)
unset(EXPORT_TARGETS)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/mip-config-version.cmake"
    COMPATIBILITY AnyNewerVersion
)

#
# Installation
#

# Only install headers that we build the source files for
set(ALL_MIP_HEADERS "${ALL_MIP_SOURCES}")
list(FILTER ALL_MIP_HEADERS INCLUDE REGEX "^.*\.(h|hpp)$")
foreach(MIP_HEADER ${ALL_MIP_HEADERS})
    string(REPLACE "${SRC_DIR}/" "" MIP_HEADER_RELATIVE "${MIP_HEADER}")
    if(INT_DIR)
        string(REPLACE "${INT_DIR}/" "" MIP_HEADER_RELATIVE "${MIP_HEADER_RELATIVE}")
    endif()
    set(MIP_HEADER_DESTINATION_FULL "${CMAKE_INSTALL_INCLUDEDIR}/${MIP_HEADER_RELATIVE}")
    get_filename_component(MIP_HEADER_DESTINATION "${MIP_HEADER_DESTINATION_FULL}" DIRECTORY)
    install(
        FILES "${MIP_HEADER}"
        DESTINATION "${MIP_HEADER_DESTINATION}"
        COMPONENT mip
    )
endforeach()

install(TARGETS
    mip
    EXPORT mip-targets
    ARCHIVE
    COMPONENT mip
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/"
)

install(EXPORT
    mip-targets
    COMPONENT mip
    DESTINATION "${CONFIG_EXPORT_DIR}"
)

install(FILES
    "${CMAKE_BINARY_DIR}/mip-config.cmake"
    "${CMAKE_BINARY_DIR}/mip-config-version.cmake"
    COMPONENT mip
    DESTINATION "${CONFIG_EXPORT_DIR}"
)

# Try to determine what architecture we are building for based on the compiler output
if(MSVC)
    # Detect if this is a x64 or x86 build
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(MIP_ARCH "x64")
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(MIP_ARCH "x86")
    endif()
elseif(UNIX)
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        # The dumpmachine command from gcc should contain information on the architecture
        execute_process(
            COMMAND ${CMAKE_COMMAND} -E env /bin/bash -c "${CMAKE_CXX_COMPILER} -dumpmachine"

=== debian/changelog ===
ros-rolling-microstrain-inertial-driver (3.1.0-1jammy) jammy; urgency=high

  * Adds several PRs from submodule (#263 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/263>)
  * Updates submodule to fix TF warning (#262 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/262>)
  * ROS Turns on antenna calibration by default, and publishes the amount corrected by (#237 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/237>)
  * Feature/ros relative position base station (#235 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/235>)
  * Contributors: Rob

 -- Rob Fisher <rob.fisher@parker.com>  Tue, 25 Jul 2023 04:00:00 -0000

ros-rolling-microstrain-inertial-driver (3.0.1-1jammy) jammy; urgency=high

  * Publishes after every packet to fix lower data rate problem (#229 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/229>)
    * Publishes after every packet to fix lower data rate problem
  * Updates submodule with microseconds to nanoseconds fix (#227 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/227>)
  * ROS Fixes odom data rate mapping to refer to the correct topic (#224 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/224>)
    * Fixes odom data rate mapping to refer to the correct topic
  * Contributors: Rob

 -- Rob Fisher <rob.fisher@parker.com>  Fri, 10 Feb 2023 05:00:00 -0000

ros-rolling-microstrain-inertial-driver (3.0.0-1jammy) jammy; urgency=high

  * Fixes for devices that do not support the extended descriptor set command in ROS (#216 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/216>)
    * Fixes for devices that do not support the extended descriptor set command in ROS
  * Validates that all publishers are documented on the wiki for ROS (#211 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/211>)
    * Fixes time_ref topics and validates that wiki has all publishers documented
  * Adds IMU overrange status publishers for ROS (#207 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/207>)
    * Adds IMU overrange status publishers for ROS
  * Adds RF error detection publishers for ROS (#206 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/206>)
    * Adds RF error detection to ROS
  * Adds SBAS info publishers for ROS (#204 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/204>)
    * Adds SBAS info publishers for ROS
  * Adds SBAS settings support to ROS (#202 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/202>)
    * Adds SBAS settings support to ROS
  * ROS Implements the filter lever arm offset command (#196 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/196>)
    * Adds ability to configure filter lever arm offset
  * Feature/ros nmea main port (#192 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/192>)
    * Adds ability to parse and publish NMEA from the main port
  * Feature/ros mip sdk (#191 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/191>)
    * Converts to use the mip_sdk instead of MSCL
    * BREAKING Removes publish_* configuration options and instead relies on more granular *_data_rate options to enable/disable data streams
    * Switches to compile as a static binary
  * Contributors: Rob

 -- Rob Fisher <rob.fisher@parker.com>  Wed, 11 Jan 2023 05:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.7.1-1jammy) jammy; urgency=high

  * Updates submodule with CV7 mag aiding bugfix (#188 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/188>)
  * Enable usage of substitution arguments in override params YAML file. (#187 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/187>)
  * ROS Do not error when the device does not support antenna offset or S2V commands (#182 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/182>)
    * Do not error when the device does not support antenna offset or S2V commands
  * Contributors: Joey Yang, Rob

 -- Rob Fisher <rob.fisher@parker.com>  Wed, 09 Nov 2022 05:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.7.0-1jammy) jammy; urgency=high

  * ROS2 serial improvements (#177 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/178>)
    * Adds logging loop every second that will print the number of bytes read and written
    * Adds ability to configure the baudrate on the device using set_baud
    * Changes *_data_rate fields to floating point numbers to allow users to configure data rates at non whole numbers
    * Fixes bug where a quaternion would be indexed into before it was populated
  * ROS2 Updates params file to note required changes for devices, and corrects incorrect documentation (#170 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/169>)
  * Contributors: Rob

 -- Rob Fisher <rob.fisher@parker.com>  Fri, 23 Sep 2022 04:00:00 -0000

ros-rolling-microstrain-inertial-driver (2.6.0-1jammy) jammy; urgency=high

  * ROS Fixes NMEA parsing to not fail when we find certain MIP packets (#159 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/159>)
    * Fixes NMEA parsing to not fail when we find certain MIP packets
  * Runs roslint on the buildfarm (#154 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/154>)
  * Fixed reporting of filter pitch and yaw when using ENU frame for ROS (#150 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/150>)
  * Adds velocity covarianve for the GNSS odometry message for ROS (#149 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/149>)
  * Adds ability to publish velocity in the vehicle frame for ROS (#145 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/145>)
  * ROS More granular data rates (#131 <https://github.com/LORD-MicroStrain/microstrain_inertial/issues/131>)
    * Adds more granular data rates to ROS


=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Rob Fisher <rob.fisher@parker.com>
-Build-Depends: debhelper (>= 9.0.0), curl, jq, libcurl4-openssl-dev, ros-rolling-ament-cmake-gtest, ros-rolling-ament-cpplint, ros-rolling-diagnostic-updater, ros-rolling-geometry-msgs, ros-rolling-lifecycle-msgs, ros-rolling-mavros-msgs, ros-rolling-microstrain-inertial-msgs, ros-rolling-nav-msgs, ros-rolling-nmea-msgs, ros-rolling-rclcpp-lifecycle, ros-rolling-ros-environment, ros-rolling-rosidl-default-generators, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-ros-workspace, ros-rolling-rosidl-typesupport-fastrtps-c, ros-rolling-rosidl-typesupport-fastrtps-cpp
+Build-Depends: debhelper (>= 9.0.0), curl, git, jq, libcurl4-openssl-dev, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-cpplint <!nocheck>, ros-rolling-diagnostic-updater, ros-rolling-geometry-msgs, ros-rolling-lifecycle-msgs, ros-rolling-mavros-msgs, ros-rolling-microstrain-inertial-msgs, ros-rolling-nav-msgs, ros-rolling-nmea-msgs, ros-rolling-rclcpp-lifecycle, ros-rolling-ros-environment, ros-rolling-rosidl-default-generators, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-ros-workspace, ros-rolling-rosidl-typesupport-fastrtps-c, ros-rolling-rosidl-typesupport-fastrtps-cpp
 Homepage: https://github.com/LORD-MicroStrain/microstrain_inertial
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
